/***************
Spuzzum's Damage Numbers Demo.

You don't need this if you include
the library in your game.  Just
include the s_[colour]nums.dmi
files and the s_damage.dm file,
and you're all set.

Oh, and play this at least once.
I'm sure you'll be laughing
afterward. =)

***************/

world
	mob = /mob/player
	view = 5


mob/employee
	Click()
		if(usr:ammo && started)
			usr:ammo--
			world << 'rifl1.wav'
			new /obj/blood(src.loc)

			var/colour = "yellow"

			var/damage = usr:Damage()

			if(prob(10)) //Critical Hit Chance, cuz you're Canadian! =)
				damage *= rand(2,5)
				colour = "red"

			s_damage(damage,colour,src)
			src.hp -= damage


			Update()

			if(!usr:ammo)
				var/obj/powerup/O = new
				var/L[0]
				for(var/turf/grass/T)
					L += T
				O.loc = L[rand(1,L.len)]
				O.icon_state = "2"

			if(src.hp < 1)
				del src


mob/player
	icon = 'player.dmi'
	var/obj/bomb/bomb
	var/move = 0

	Login()
		src.bomb = new
		usr << "<font size=+2>S_DAMAGE DEMO</font>"
		usr << "You're a Canadian marine, and you've got a big \
			problem on your hands.  Yes, it seems Costco is after \
			you.  Why?  You didn't pay your membership fee."
		usr << "And, of all days, they chose to chase you down \
			and badger you when you had your rifle assigned to you."
		usr << null
		usr << "So what do you do now?  Well, that's pretty self-\
			evident, isn't it..."
		usr << null
		usr << "Pick up things by walking over top of them.  \
			Get more ammo when you need it, click on Costco employees \
			to shoot them.  Click the Bomb icon in your panel to wipe \
			'em all out.  Increase the power of your weapon whenever \
			you can... the employees only get stronger and stronger \
			as they go along.  There's no stopping them!"
		usr << "If they reach you, you're a goner... hey, you might \
			be a marine, but you can't fight against their legalese."
		usr << null
		usr << "See how long you can survive against the onslaught..."
		song()
		src.loc = locate(7,7,1)
		src.client.eye = locate(7,7,1)
		StartGame()

	Stat()
		statpanel("Vitals")
		stat("----------",src.bomb)
		stat("Ammo:",src.ammo)
		stat("Minimum Dmg:",src.weapon_min)
		stat("Maximum Dmg:",src.weapon_max)
		stat(" ---------","-----------")
		stat("Powerup Probs:","")
		stat("Gun Prob:","[gun_prob]%")
		stat("Ammo Prob:","[ammo_prob]%")
		stat("Bomb Prob:","[bomb_prob]%")
		if(started)
			stat("Time:",Time())

	verb
		song()
			usr << sound(pick('finiculi.mid','bumblebee.mid'),1)

		restart()
			world.Reboot()

	Move(loc)
		if(src.move)
			. = ..()
		else
			src.dir = get_dir(src,loc)
		for(var/obj/powerup/O in src.loc)
			O.Get(src)
		return .

	var
		weapon_max = 5
		weapon_min = 1
		ammo = 100

	proc/Damage()
		return rand(weapon_min,weapon_max)

proc/StartGame()
	usr << "--- 5 ---"
	sleep(10)
	usr << "--- 4 ---"
	sleep(10)
	usr << "--- 3 ---"
	sleep(10)
	usr << "--- 2 ---"
	sleep(10)
	usr << "--- 1 ---"
	sleep(10)
	usr << "--- GO! ---"
	started = 1
	InitialiseSpawners()
	Spawn()
	SpawnPowerups()
	DecreaseDelay()
	player.icon_state = ""
	player.move = 1

var/delay = 50
var/spawners[0]
var/employee_count
var/mob/player/player
var/started = 0

var/gun_prob = 30
var/ammo_prob = 30
var/bomb_prob = 30

proc/InitialiseSpawners()
	for(var/obj/spawner/spawner)
		spawners += spawner
	for(var/mob/player/O)
		player = O

proc/Spawn()
	if(started)
		var/obj/spawner/O = spawners[rand(1,spawners.len)]
		new /mob/employee(O.loc)
		spawn(rand(1,delay)) Spawn()

proc/SpawnPowerups()
	if(started)
		var/obj/powerup/O = new
		var/L[0]
		for(var/turf/grass/T)
			L += T
		O.loc = L[rand(1,L.len)]
		spawn(rand(100,300)) SpawnPowerups()

proc/DecreaseDelay()
	if(started)
		spawn(rand(1,200))
			delay--
			DecreaseDelay()

obj/spawner
	density = 1

obj/powerup
	icon = 'powerups.dmi'
	New()
		..()
		src.icon_state = pick(prob(gun_prob);"1",prob(ammo_prob);"2",prob(bomb_prob);"3")
		switch(src.icon_state)
			if("1")
				gun_prob -= 10
				ammo_prob += 5
				bomb_prob += 5
			if("2")
				gun_prob += 5
				ammo_prob -= 10
				bomb_prob += 5
			if("3")
				gun_prob += 5
				ammo_prob += 5
				bomb_prob -= 10

	proc/Get(mob/player/M)
		switch(icon_state)
			if("1")
				M.weapon_max += rand(5,10)
				M.weapon_min += rand(1,5)
			if("2")
				M.ammo += rand(20,100)
			if("3")
				M.bomb.num++
				M.bomb.Update()
		del(src)


turf
	icon = 'grass.dmi'
	icon_state = "1"
	Click()
		for(var/mob/employee/O in src)
			O.Click()
	New()
		..()
		src.icon_state = "[rand(1,5)]"
	grass

obj/bomb
	name = "Bomb (x3)"
	icon = 'powerups.dmi'
	icon_state = "3"
	var/num = 3
	Click()
		if(!started)
			return
		if(num)
			world << 'bomb.wav'
			for(var/mob/employee/O)
				s_damage(9999,"red",O)
				new /obj/blood(locate(O.x+1,O.y+1,O.z))
				new /obj/blood(locate(O.x,O.y+1,O.z))
				new /obj/blood(locate(O.x-1,O.y+1,O.z))
				new /obj/blood(locate(O.x-1,O.y,O.z))
				new /obj/blood(locate(O.x-1,O.y-1,O.z))
				new /obj/blood(locate(O.x,O.y-1,O.z))
				new /obj/blood(locate(O.x+1,O.y-1,O.z))
				new /obj/blood(locate(O.x+1,O.y,O.z))
				new /obj/explosion(O.loc)
				del(O)
			num--
			Update()
	proc/Update()
		src.name = "Bomb (x[src.num])"

obj/explosion
	icon = 'explosion.dmi'
	New()
		..()
		src.icon_state = "[rand(1,3)]"
		Delete()
	proc/Delete()
		spawn(5)
			del(src)


mob/employee
	icon = 'employees.dmi'
	var/hp = 1
	New()
		..()
		src.icon_state = "[rand(1,4)]"
		employee_count++
		src.hp = employee_count
		Update()
		Zombie()

	Bump(mob/O)
		if(istype(O,/mob/player))
			if(started)
				started = 0
				world << "<font size=+2>Game over!</font>"
				world << "You've been captured after [Time()] of hard \
					fighting..."
				world << "After a long legal battle, you find you have to \
					pay $60 per year for the rest of your life."
				world << "It is a sad, sad day in the world of wholesale."
				O.icon_state = "captured"
				O:move = 0
				world << sound('heck.mid',1)
			else
				if(prob(5)) s_damage(60,"yellow",player)

	proc/Update()
		src.name = "employee ([src.hp] HP)"

	proc/Zombie()
		var/dir = get_dir(src,player)
		if(get_dist(src,player) > 1)
			var/turf/T = get_step(src,pick(dir,turn(dir,45),turn(dir,-45)))
			src.Move(T)
		else
			src.Move(player.loc)

		spawn(rand(5,10)) Zombie()


obj/blood
	icon = 'blood.dmi'
	New()
		..()
		src.icon_state = pick("ul","u","ur","l","c","r","dl","d","dr")
		spawn(rand(50,100))
			del src


proc/Time()
	var/hours = 0;var/minutes = 0;var/seconds = 0;var/temp
	temp = world.time-50
	seconds = round(temp/10)
	while(seconds >= 60)
		seconds -= 60
		++minutes
	while(minutes >= 60)
		minutes -= 60
		++hours
	if(minutes < 10)
		minutes = num2text(minutes)
		minutes = "0[minutes]"
	if(seconds < 10)
		seconds = num2text(seconds)
		seconds = "0[seconds]"
	return "[hours]:[minutes]:[seconds]"


/*  This is a cool snippet... I was originally
  going to use it, until I realized that in this
  circumstance, pick() could be used.

    Just pass in a list of probs (in the format
  list(10,20,40,20,10)) and a list of possible
  results (in the format list(1,2,3,4,5)), and
  it'll work like an advanced pick, without
  pre-requisite hard-coded choices.  In other
  words, this is a run-time based version of
  pick().
*/

/*
proc/WeightedProbChoice(list/Probs, list/Choices)
	var/i
	var/running_total
	var/probability = rand(1,100)

	for(i = 1; i <= Probs.len; i++)
		running_total += Probs[i]
		if(probability <= running_total)
			return Choices[i]
*/